(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global = global || self, global.joUtil = factory());
}(this, (function () { 'use strict';

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
  }

  function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
  }

  function _iterableToArrayLimit(arr, i) {
    if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"] != null) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

    return arr2;
  }

  function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  var _arguments = arguments;

  /**
   * 工具函数
   */
  var noop = function noop() {};
  var d = document.createElement('div');
  var isSupport = function isSupport(prop) {
    if (['getBoundingClientRect'].indexOf(prop) > -1) {
      return !!d[prop];
    }

    if (['Event'].indexOf(prop) > -1) {
      return !!window[prop];
    }

    return false;
  }; // 获取数据类型

  var toString = Object.prototype.toString;
  var whatType = function whatType(obj) {
    return toString.call(obj).match(/\w+/g)[1];
  }; // 是否字符类型

  var isString = function isString(obj) {
    return whatType(obj) == 'String';
  }; // 是否数字类型

  var isNumber = function isNumber(obj) {
    return whatType(obj) == 'Number';
  }; // 是否函数类型

  var isFunction = function isFunction(obj) {
    return whatType(obj) == 'Function';
  }; // 获取元素

  var getEl = function getEl(selector) {
    var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document;

    if (isString(selector)) {
      return context.querySelector(selector);
    } else {
      return selector;
    }
  }; // 获取元素集合

  var getEls = function getEls(selector) {
    var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document;

    if (isString(selector)) {
      return context.querySelectorAll(selector);
    } else {
      return selector;
    }
  }; // 解析成html

  var parseHTML = function parseHTML(html) {
    if (!parseHTML.el) {
      parseHTML.el = document.createElement('div');
    }

    parseHTML.el.innerHTML = html;
    return parseHTML.el.children[0];
  };
  /**
   * @param {Element} el 元素
   * @param {String} type 事件类型
   * @param {Function} fn 事件函数
   * @return {Function} 返回事件解绑
   */

  var addEvent = function addEvent(el, type) {
    var fn = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : noop;
    el = getEl(el);
    el.addEventListener(type, fn, false);
    return function () {
      removeEvent(el, type, fn);
    };
  };
  /**
   * @param {Element} el 元素
   * @param {String} type 事件类型
   * @param {Function} fn 事件函数
   */

  var removeEvent = function removeEvent(el, type) {
    var fn = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : noop;
    el = getEl(el);
    el.removeEventListener(type, fn);
  }; // 触发事件

  var dispatchEvent = function dispatchEvent(type) {
    var obj = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document;
    var e;

    if (isSupport('Event')) {
      e = new Event(type);
    } else {
      e = obj.document.createEvent('UIEvents');
      e.initUIEvent(type, true, false, obj, 0);
    }

    obj.dispatchEvent(e);
  }; // 获取事件，非严格模式使用

  var getEvent = function getEvent() {
    if (window.event) {
      return window.event;
    }

    var f = _arguments.callee.caller;

    do {
      var e = f.arguments[0];

      if (e && (e.constructor === Event || e.constructor === MouseEvent || e.constructor === KeyboardEvent)) {
        return e;
      }
    } while (f = f.caller);
  }; // 添加样式class

  var addClass = function addClass(el, name) {
    if (!hasClass(el, name)) {
      el.classList.add(name);
    }
  }; // 删除样式class

  var removeClass = function removeClass(el, name) {
    if (hasClass(el, name)) {
      el.classList.remove(name);
    }
  }; // 切换样式class

  var toggleClass = function toggleClass(el, name) {
    if (!hasClass(el, name)) {
      addClass(el, name);
    } else {
      removeClass(el, name);
    }
  };
  var hasClass = function hasClass(el, name) {
    return (' ' + el.className + ' ').indexOf(' ' + name + ' ') > -1;
  }; // 获取元素页面位置

  var getOffset = function getOffset(el) {
    var x = 0;
    var y = 0;

    while (el) {
      x += el.offsetLeft;
      y += el.offsetTop;
      el = el.offsetParent;
    }

    return {
      x: x,
      y: y
    };
  }; // 获取元素位置、大小信息

  var getClientRect = function getClientRect(el) {
    if (isSupport('getBoundingClientRect')) {
      return el.getBoundingClientRect();
    } else {
      var offset = getOffset(el);
      return _objectSpread2({
        width: el.offsetWidth,
        height: el.offsetHeight
      }, offset);
    }
  }; // 碰撞检测 点[x1, y1] => 区域[x2, y2, w2, h2]

  var testColl = function testColl(_ref, _ref2) {
    var _ref3 = _slicedToArray(_ref, 2),
        x1 = _ref3[0],
        y1 = _ref3[1];

    var _ref4 = _slicedToArray(_ref2, 4),
        x2 = _ref4[0],
        y2 = _ref4[1],
        w2 = _ref4[2],
        h2 = _ref4[3];

    return x1 > x2 && x1 < x2 + w2 && y1 > y2 && y1 < y2 + h2;
  }; // 碰撞检测 物体[x1, y1, w1, h1] => 区域[x2, y2, w2, h2]

  var testColl2 = function testColl2(_ref5, _ref6) {
    var _ref7 = _slicedToArray(_ref5, 4),
        x1 = _ref7[0],
        y1 = _ref7[1],
        w1 = _ref7[2],
        h1 = _ref7[3];

    var _ref8 = _slicedToArray(_ref6, 4),
        x2 = _ref8[0],
        y2 = _ref8[1],
        w2 = _ref8[2],
        h2 = _ref8[3];

    return x1 < x2 + w2 && x1 + w1 > x2 && y1 < y2 + h2 && y1 + h1 > y2;
  }; // 存储

  var storage = {
    local: function local(key, val) {
      if (arguments.length <= 1) {
        return localStorage.getItem(key);
      } else {
        localStorage.setItem(key, val);
      }
    },
    removeLocal: function removeLocal(key) {
      localStorage.removeItem(key);
    },
    session: function session(key, val) {
      if (arguments.length <= 1) {
        return sessionStorage.getItem(key);
      } else {
        sessionStorage.setItem(key, val);
      }
    },
    removeSession: function removeSession(key) {
      sessionStorage.removeItem(key);
    }
  }; // 复制文本

  var copyText = function copyText(text) {
    var el = document.createElement('textarea'); // el.style.display = 'none';

    document.body.appendChild(el);
    el.value = text;
    el.select(); // 选中文本

    document.execCommand("copy"); // 执行浏览器复制命令

    document.body.removeChild(el);
  }; // 防抖

  var debounce = function debounce() {
    var fn = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;
    var delay = arguments.length > 1 ? arguments[1] : undefined;
    var timer = null;
    return function (data) {
      clearTimeout(timer);
      timer = setTimeout(function () {
        fn(data);
      }, delay);
    };
  }; // 节流

  var throttle = function throttle() {
    var fn = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;
    var delay = arguments.length > 1 ? arguments[1] : undefined;
    var valid = true;
    return function (data) {
      if (!valid) {
        // 休息时间 暂不接客
        return false;
      }

      valid = false;
      setTimeout(function () {
        fn(data);
        valid = true;
      }, delay);
    };
  }; // sleep

  var sleep = function sleep() {
    return new Promise(function (resolve, reject) {
      resolve(null);
    });
  };

  var util = /*#__PURE__*/Object.freeze({
    __proto__: null,
    noop: noop,
    isSupport: isSupport,
    whatType: whatType,
    isString: isString,
    isNumber: isNumber,
    isFunction: isFunction,
    getEl: getEl,
    getEls: getEls,
    parseHTML: parseHTML,
    addEvent: addEvent,
    removeEvent: removeEvent,
    dispatchEvent: dispatchEvent,
    getEvent: getEvent,
    addClass: addClass,
    removeClass: removeClass,
    toggleClass: toggleClass,
    hasClass: hasClass,
    getOffset: getOffset,
    getClientRect: getClientRect,
    testColl: testColl,
    testColl2: testColl2,
    storage: storage,
    copyText: copyText,
    debounce: debounce,
    throttle: throttle,
    sleep: sleep
  });

  return util;

})));
